;=====================================================
; MAIN ATYPEX.DLL SOURCE CODE FILE
;=====================================================

ATX_VERSION			equ	'2.10'
DEBUG_MODE			=	FALSE		; (not currently implemented)
PLUGIN_DEBUG_MODE		=	FALSE		; (not currently implemented)

; alignment values (can be used to balance DLL size vs code/data access speed - doesn't really mattter)
DSTR_STRING_ALIGNMENT		=	0
ATINITPROC_ALIGNMENT		=	16
ATXINITPROC_ALIGNMENT		=	16
ATXPROC_ALIGNMENT		=	16
CHEATPROC_ALIGNMENT		=	16
INTERCEPTPROC_ALIGNMENT 	=	16

;=================================================================
format PE GUI 4.0 DLL at 1500000h
entry DllEntryPoint
;=================================================================
; constants, structures, virtual data, macros

include '%fasminc%\WIN32A.INC'				; must have FASM environment variable set properly for this
include 'base\defs.inc' 				; special definitions

include 'components\constants.inc'
include 'components\macros.inc'

include 'components\structs.inc'
include 'components\structs2.inc'
include 'components\structs3.inc'

include 'base\structscustombegin.inc'
include 'components\structscustom.inc'
include 'base\structscustomend.inc'

include 'components\virtualdata.inc'

;=================================================================
section '.code' code readable executable
;=================================================================
; main (and only) code section

include 'components\codert.inc'
include 'components\codeprocs.inc'
include 'components\codecommand.inc'
include 'components\codeatinit.inc'

;-----------------------------------
ATXPROC DllEntryPoint
;-----------------------------------

	mov eax,[esp+8]

	cmp eax,DLL_PROCESS_ATTACH
	jz .dllload

	mov eax,TRUE

ret 12

.dllload:

	mov ecx,[esp+4]
	mov eax,TRUE
	mov [dllhandle],ecx

ret 12

;-----------------------------------
proc ATYPEXDllInit uses esi edi ebx, lpUnloadProc, lpExitProcessAddr, lpMSVCRTexitAddr, lpMSVCRT_exitAddr
;-----------------------------------
; initializes DLL for specific Trespasser EXE
; note: cannot acccess params directly during initialization,
;       because ebp is used for other than stack frames
; return values:
; eax = TRUE if load success, FALSE if error
; ecx = pointer to MessageBox text if error or NULL to use default EXE message

	mov eax,[lpUnloadProc]
	mov edx,[lpExitProcessAddr]
	mov [exeunloadcodeproc],eax
	mov [exeExitProcessvaraddr],edx

	mov eax,[lpMSVCRTexitAddr]
	mov edx,[lpMSVCRT_exitAddr]
	mov [exeMSVCRTexitvaraddr],eax
	mov [exeMSVCRT_exitvaraddr],edx

	push ebp					; ebp -> used for error logging ONLY !!!
	xor ebp,ebp

include 'base\codeinitbegin.inc'
include 'components\codeinit.inc'
include 'base\codeinitend.inc'

ExitInit:

	pop ebp

	test [DLLLoadSuccessBool],TRUE
	jz .initsuccess

		call ATYPEXDllUninit			; call uninit if init error

	.initsuccess:

	xor eax,eax
	mov ecx,[DLLLoadExitMsgAddr]			; exit message (if NULL, will use default EXE msg)
	test [DLLLoadSuccessBool],TRUE
	setz al 					; return DLL load success/error (FALSE = error)

ret
endp

include 'base\codeuninitintercepts.inc'

;-----------------------------------
ATXPROC ATYPEXDllUninit
;-----------------------------------
; called from 'base\codeuninitintercepts.inc'
; frees all potentially loaded buffers and deletes temporary files

include 'base\codeuninitbegin.inc'
include 'components\codeuninit.inc'
include 'base\codeuninitend.inc'

ret

;=================================================================
section '.data' data readable writeable
;=================================================================
; readable/writable data

align 16
include 'components\datainit.inc'

align 16
include 'components\datart.inc'

;=================================================================
section '.rdata' data readable
;=================================================================
; read-only data

align 16
include 'components\constantdata.inc'

align 16
include 'components\constantstrings.inc'


align 16
DemoEXERepCodeStart:
file 'resources\tpassdemorepcode.bin'
DemoEXERepCodeEnd:

;=================================================================
section '.idata' import data readable writeable
;=================================================================
; imported DLL functions

include 'base\imports.inc'

;=================================================================
section '.edata' export data readable
;=================================================================
; exported ATYPEX.dll functions (i.e., to EXE code, plugins, etc.)

include 'base\exports.inc'

;=================================================================
section '.rsrc' resource data readable
;=================================================================
; resources (small bitmaps, dll version info, etc.)

	directory RT_BITMAP,bmps,\
		  RT_VERSION,versions

	resource bmps,\
		 100,LANG_NEUTRAL,blinkerbmp,\
		 101,LANG_NEUTRAL,aimdotbmp,\
		 102,LANG_NEUTRAL,tracesbmp

	resource versions,1,LANG_NEUTRAL,version

	bitmap blinkerbmp,"resources\blinker.bmp"
	bitmap aimdotbmp,"resources\aimdot.bmp"
	bitmap tracesbmp,"resources\traces.bmp"

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
		    'FileDescription','Part of the ATX Trespasser modification',\
		    'LegalCopyright','Free, open source.',\
		    'FileVersion',ATX_VERSION,\
		    'ProductVersion',ATX_VERSION,\
		    'OriginalFilename','ATYPEX.DLL'

;=================================================================
section '.reloc' fixups data discardable readable
;=================================================================
