;==========================================================
ATXPROC AT114MAIN
;==========================================================
; Randomized instance teleporter real-time function

push ebp
mov ebp,esp
sub esp,32
push esi
push edi
push ebx
mov esi,ecx

	mov eax,[esi+CAT114.TotalProbabilityCount]
	test eax,eax
	jz .exit

	stdcall GetRandomNumber,eax

	mov edx,[esi+CAT114.lpGroupsProbabilitiesList]

	.getrandominstanceloop:
	sub eax,[edx]
	jbe .getrandominstanceloopend
	add edx,4
	jmp .getrandominstanceloop
	.getrandominstanceloopend:

	sub edx,[esi+CAT114.lpGroupsProbabilitiesList]
	mov eax,edx
	shr eax,2
	inc eax
	mov [ebp-24],eax					; store group number
	mov eax,[esi+CAT114.NumberOfInstances]
	mul edx
	mov edx,eax
	shr eax,2
	add eax,[esi+CAT114.lpGroupLocationFlags]
	add edx,[esi+CAT114.lpGroupData]
	mov [ebp-4],eax 					; [ebp-4] = base index for flags
	mov [ebp-8],edx 					; [ebp-8] = base index for pointers


  ;  /*   Check if inner group randomization flag is set for this group - NEW IN ATX 2.09

	mov DWORD [ebp-32],0					; pointer to a temp buffer of DWORD numbers

	mov eax,[ebp-24]
	add eax,[esi+CAT114.lpGroupsFlags]
	test BYTE [eax-1],AT114_GROUP_RANDOMIZELOCATIONSINGROUP
	jz .norandomizeinner

		mov eax,[esi+CAT114.NumberOfGroups]		; create buffer of DWORD indexes 0..NumberOfGroups
		shl eax,2
		invoke LocalAlloc,LMEM_FIXED,eax
		mov [ebp-32],eax

		xor ecx,ecx
		mov edx,[esi+CAT114.NumberOfInstances]
		.increasingindexloop:
		mov [eax],ecx
		add eax,4
		inc ecx
		cmp ecx,edx
		jb .increasingindexloop

	.norandomizeinner:
  ;  */

	xor ebx,ebx
	mov [ebp-28],ebx					; NEW IN ATX 2.09: [ebp-28] now counter instead of ebx
	mov edi,AT18SimObject

	.teleportloop:

  ; /* check if inner randomization enabled - NEW IN ATX 2.09

	mov ebx,[ebp-28]
	cmp DWORD [ebp-32],0
	jz .noinnerlooprand

		neg ebx
		add ebx,[esi+CAT114.NumberOfInstances]
		stdcall GetRandomNumber,ebx
		mov ecx,[ebp-32]
		lea eax,[(eax-1)*4+ecx] 					; get next random index between (start of index list) and (number of instances left to teleport)
		lea edx,[(ebx-1)*4+ecx]
		mov ebx,[eax]							; next randomly chosen index
		mov ecx,[edx]
		mov [eax],ecx							; put highest index into position of chosen index

	.noinnerlooprand:

  ; */

	mov ecx,[ebp-4]
	mov al,[ebx+ecx]					; flags
	test al,AT114_LOC_ENTRYVALID
	jz .noteleport

	test al,AT114_LOC_USEHEIGHTRELATIVE
	setnz cl
	test al,AT114_LOC_USEONTERRAIN
	setnz dl
	mov [edi+CTeleportAction.HeightRelativeBOOL],cl
	mov [edi+CTeleportAction.OnTerrainBOOL],dl
	test al,AT114_LOC_USESETPOSITION
	setnz cl
	test al,AT114_LOC_USESETORIENTATION
	setnz dl
	mov [edi+CTeleportAction.SetPositionBOOL],cl
	mov [edi+CTeleportAction.SetOrientationBOOL],dl

	mov ecx,[ebp-8]
	mov edx,[ebx*4+ecx]					; pointer
	test al,AT114_LOC_USEDESTOBJECT
	jz .nodestobject

; use destination object for location values

	GETINSTANCEFROMID32 edx
	lea ecx,[ebx+1]
	test eax,eax
	mov edx,[ebp-24]					; group number in case of error
	mov [AT114LastError],AT114_ERRORSTR_RT_INVALIDDESTOBJ
	mov [AT114LastErrorDParam1],ecx
	mov [AT114LastErrorDParam2],edx
	jz .error

	push esi
	push edi
	lea esi,[eax+CInstance.Location]
	lea edi,[edi+CTeleportAction.TargetInstanceLocationSet]
	mov ecx,7
	rep movsd
	pop edi
	pop esi
	jmp .doteleport

	.nodestobject:

; use X,Y,Z location values

	cmp [edi+CTeleportAction.SetPositionBOOL],1
	jnz .noposition

		mov eax,[edx]
		mov ecx,[edx+4]
		mov [edi+CTeleportAction.TargetInstanceLocationSet.X],eax
		mov [edi+CTeleportAction.TargetInstanceLocationSet.Y],ecx
		mov eax,[edx+8]
		mov [edi+CTeleportAction.TargetInstanceLocationSet.Z],eax
		add edx,12

	.noposition:

	cmp [edi+CTeleportAction.SetOrientationBOOL],1
	jnz .noorientation

		mov eax,[edx]
		mov ecx,[edx+4]
		mov [edi+CTeleportAction.TargetInstanceOrientationSet.W],eax
		mov [edi+CTeleportAction.TargetInstanceOrientationSet.X],ecx
		mov eax,[edx+8]
		mov ecx,[edx+12]
		mov [edi+CTeleportAction.TargetInstanceOrientationSet.Y],eax
		mov [edi+CTeleportAction.TargetInstanceOrientationSet.Z],ecx

	.noorientation:

	.doteleport:

	mov eax,[esi+CAT114.lpInstanceList]

	mov edx,[ebp-28]					;
	mov edx,[edx*4+eax]					; MODIFIED IN ATX 2.09 - instance counter [ebp-28] may be different from dest location index (ebx)

	mov [edi+CTeleportAction.RefCount],0
	mov [edi+CTeleportAction.TargetInstanceNameID],edx
	mov eax,[edi]
	mov ecx,edi
	call [eax+ICAction.MainProc]

	.noteleport:

	mov eax,[ebp-28]						; MODIFIED IN ATX 2.09
	inc eax
	mov [ebp-28],eax

	cmp eax,[esi+CAT114.NumberOfInstances]
	jb .teleportloop


    ;   free temp buffer (NEW IN ATX 2.09)

	LOCALRELEASENONULL DWORD [ebp-32]


.exit:
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret
;*/

.error:

    ;   free temp buffer (NEW IN ATX 2.09)

	LOCALRELEASENONULL DWORD [ebp-32]


	mov esi,AT114_ERRORSTR_RT_MAIN
	mov edi,AT114MessageBuffer
	call TransferString

	mov [AT114TempVar],esp
	invoke sprintf,edi,[AT114LastError],[AT114LastErrorDParam1],\
		       [AT114LastErrorDParam2],[AT114LastErrorDParam3],\
		       [AT114LastErrorDParam4],[AT114LastErrorDParam5]
	mov esp,[AT114TempVar]

	add eax,AT114_ERRORSTR_RT_MAIN.size
	stdcall WriteLogFileInGame,AT114MessageBuffer,eax

	xor eax,eax
	mov DWORD [eax],0

pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret

