
;===================================================================
proc ObjValDisplayValues lpInstance,hDC,Xoff,Yoff
;===================================================================
; eax = pointer to OBJVALLOCINFO macro table
; returns next line position in eax
push esi
push ebx
push edi

	mov ebx,[eax]
	lea esi,[eax+4]
	mov edi,[Yoff]

	.processloop:

	cmp [esi+ObjValLocatorInfo.Enabled],0
	jz .noprintout


		push edi

		push esi

		mov esi,[esi+ObjValLocatorInfo.lpDisplayName]
		lea edi,[ObjValStringBuf]

		test esi,esi
		jz .nodisplaynameorseparator

			call TransferString
			mov esi,OBJVAL_FORMAT_SEPARATOR
			call TransferString

		.nodisplaynameorseparator:

		pop esi

		mov eax,[lpInstance]
		call ObjValFollowAndFormatValue
		test eax,eax
		jnz .valueprinted

			pop edi
			jmp .noprintout

		.valueprinted:
		add eax,edi
		sub eax,ObjValStringBuf

		pop edi

		lea edx,[ObjValStringBuf]
		invoke TextOut,[hDC],[Xoff],edi,edx,eax

		add edi,TEXTOUT_DEFAULT_LINE_HEIGHT


	.noprintout:

	add esi,sizeof.ObjValLocatorInfo
	dec ebx
	jnz .processloop

	mov eax,edi

pop edi
pop ebx
pop esi
ret
endp


;===================================================================
ATXPROC ObjValFollowAndFormatValue
;===================================================================
; esi = ObjValLocatorInfo instance (unchanged)
; eax = base address of game object
; edi = pointer to buffer (unchanged)
; returns number of bytes in string

	mov edx,[esi+ObjValLocatorInfo.lpIndirects]
	mov ecx,[edx]					; number of indirects

	.indirectsloop:
	add edx,4
	add eax,[edx]
	dec ecx 					; (always at least one indirect, may be 0)
	jz .endindirectsloop
	     mov eax,[eax]				; if not last offset, is a pointer
	jmp .indirectsloop
	.endindirectsloop:

      ; eax = pointer to data type

	mov edx,edi
	mov ecx,[esi+ObjValLocatorInfo.ValueType]

	cmp [esi+ObjValLocatorInfo.lpFormatCallback],0
	jnz .hascallback

	call TypeToString

ret

.hascallback:
	call [esi+ObjValLocatorInfo.lpFormatCallback]
ret


;===================================================================
ATXPROC ObjValToggleEntryEnabled
;===================================================================
; eax = pointer to OBJVALLOCINFO macro table
; esi = key name of entry (unchanged)
; returns true if success, false if keyname doesn't exist

push ebx
push edi

	mov ebx,[eax]
	lea edi,[eax+4]

	.findloop:

		mov ecx,esi
		mov edx,[edi+ObjValLocatorInfo.lpKeyName]
		call CompareStrings
		test eax,eax
		jnz .found

	add edi,sizeof.ObjValLocatorInfo
	dec ebx
	jnz .findloop

	xor eax,eax
pop edi
pop ebx
ret

.found:
	xor [edi+ObjValLocatorInfo.Enabled],1
	mov eax,TRUE
pop edi
pop ebx
ret



;==========================================================
ATXINITPROC INI_CHECKNEWOBJVALDISPLAYSINITPROC
;==========================================================
; eax = pointer to OBJVALLOCINFO macro table
; edx = section name
push esi
push edi
push ebx

	mov ebx,[eax]
	lea esi,[eax+4]
	mov edi,edx
	.iniscanloop:

	xor eax,eax
	mov al,[esi+ObjValLocatorInfo.Enabled]
	invoke GetPrivateProfileInt,edi,[esi+ObjValLocatorInfo.lpKeyName],eax,atxconfigpath_const

	cmp eax,1
	jna @f
		mov eax,1
	@@:
	mov [esi+ObjValLocatorInfo.Enabled],al

	add esi,sizeof.ObjValLocatorInfo
	dec ebx
	jnz .iniscanloop


pop ebx
pop edi
pop esi
ret

;==========================================================
ATXINITPROC UpdateATXConfigINIObjValEnabled
;==========================================================
; ebp = file handle
; eax = pointer to OBJVALLOCINFO macro table
; edx = section name

; uses ATXConfigValueBuffer

push esi
push ebx

	mov ebx,[eax]
	lea esi,[eax+4]

   ; print section name

	cinvoke wsprintf,ATXConfigValueBuffer,INI_SECTION_TEMPLATE_CRET,edx

	sub esp,4
	mov edx,esp
	invoke WriteFile,ebp,ATXConfigValueBuffer,eax,edx,0
	add esp,4

   ; print values

	.iniwriteloop:

	mov al,[esi+ObjValLocatorInfo.Enabled]
	or al,[esi+ObjValLocatorInfo.DefaultState]
	jz .printonlyexplicit

		xor eax,eax
		mov al,[esi+ObjValLocatorInfo.Enabled]
		cinvoke wsprintf,ATXConfigValueBuffer,INI_KEYVALUE_INT_TEMPLATE_CRET,\
				 [esi+ObjValLocatorInfo.lpKeyName],eax

		sub esp,4
		lea edx,[esp]
		invoke WriteFile,ebp,ATXConfigValueBuffer,eax,edx,0
		add esp,4

	.printonlyexplicit:

	add esi,sizeof.ObjValLocatorInfo
	dec ebx
	jnz .iniwriteloop

pop ebx
pop esi
ret







