;============================================================
ATXPROC OpenReadFullFile	; param1=filename, param2=minimum file size, param3 = max file size (-1 if none/4GB)
;============================================================
; returns pointer to buffer in eax if success, null if failure
; returns buffer size in ecx if success

push ebp
mov ebp,esp
sub esp,12
push ebx

	xor ebx,ebx					; file handle
	mov [ebp-4],ebx 				; memory pointer
	mov [ebp-8],ebx 				; size of file/memory space
	mov [ebp-12],ebx				; number of bytes read

	invoke CreateFile,[ebp+8],GENERIC_READ,FILE_SHARE_READ,0,\
			  OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	    jz .failed

	mov ebx,eax

	invoke GetFileSize,ebx,0
	cmp eax,-1
	    jz .failed
	cmp eax,[ebp+16]
	    ja .failed
	cmp eax,[ebp+12]
	    jb .failed

	mov [ebp-8],eax

	invoke SetFilePointer,ebx,0,0,FILE_BEGIN
	cmp eax,-1
	    jz .failed

	invoke LocalAlloc,LMEM_FIXED,[ebp-8]
	test eax,eax
	mov [ebp-4],eax
	     jz .failed

	lea edx,[ebp-12]
	invoke ReadFile,ebx,eax,[ebp-8],edx,0
	test eax,eax
	mov ecx,[ebp-12]
	     jz .failed
	cmp ecx,[ebp-8]
	    jnz .failed

	invoke CloseHandle,ebx

	mov eax,[ebp-4]
	mov ecx,[ebp-8]

pop ebx
mov esp,ebp
pop ebp
ret 12

.failed:

	CLOSEHANDLE ebx
	LOCALRELEASENONULL DWORD [ebp-4]
	xor eax,eax
	xor ecx,ecx

pop ebx
mov esp,ebp
pop ebp
ret 12

;============================================================
ATXPROC GetINIFloat			; returns 32-bit float in eax (null if doesn't exist or if 0)
;============================================================
; a.k.a. GetPrivateProfileFloat

; [esp+4]  = points to section name
; [esp+8]  = points to key name
; [esp+12] = default string if none found (pointer)
; [esp+16] = points to INI filename

push ebp
mov ebp,esp
sub esp,104

	lea edx,[ebp-100]
	invoke GetPrivateProfileString,[ebp+8],[ebp+12],[ebp+16],edx,\
				       100,[ebp+20]

	lea edx,[ebp-104]
	lea eax,[ebp-100]

	cmp BYTE [eax],';'
	    jnz @f

		mov eax,[ebp+16]
		jmp .noemptyfloatentry

	@@:

	cmp BYTE [eax],0
	    jnz .noemptyfloatentry

		mov eax,[ebp+16]

	.noemptyfloatentry:

	cinvoke sscanf,eax,FLOAT_STR,edx

	pop eax

mov esp,ebp
pop ebp
ret 16

