;============================================================
ATXPROC SetRandomInstanceStartPositions
;============================================================
; [ebp-12] = number of ENTRY sections
; [ebp-8] = bool buffer
; [ebp-4] = number of ENTRY sections (variable)

cmp [UseRandomInstanceLocations],0
    jz .featuredisabled

push ebp
mov ebp,esp
sub esp,12

	mov edi,mapsdirpath
	add edi,[mapsdirpathlength]
	mov esi,[LEVELNAME_OBJ] 		; SCN level name
	mov DWORD [edi],'RAN\'			; 'RAN\' folder
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.ini'		; modify extension

; get number of ENTRY sections

	invoke GetPrivateProfileInt,MAIN_SECTION,ENTRY_COUNT,1500000,mapsdirpath
	cmp eax,1500000
	    jz .exit				; file not found?

	mov [ebp-12],eax
	mov [ebp-4],eax

	test eax,eax
	     jz .noallocentrybuf

	invoke LocalAlloc,LPTR,eax		; boolean buffer for ENTRYs
	test eax,eax
	     jz .exit

	.noallocentrybuf:
	mov [ebp-8],eax

	call RANDOMIZE_RANDOM_PROC
	xor ebx,ebx
	call MainDinoRandomizeProc

	LOCALRELEASE DWORD [ebp-8]

.exit:
mov esp,ebp
pop ebp
.featuredisabled:
ret

;============================================================
ATXPROC MainDinoRandomizeProc
;============================================================
; ebx=Instance specifier/count
; RANInstanceNameBuffer = "Instance#" string INI value (instance name)
; RANReserveEntryBuffer = "Reserved#" string INI value (may be replaced by "ENTRY#" string later)

	.randomizeloop:

	add ebx,1

	cinvoke wsprintf,RANBuffer,INSTANCE_STRING,ebx

; get associated instance's name

	invoke GetPrivateProfileString,MAIN_SECTION,RANBuffer,NULL_STRING,\
				       RANInstanceNameBuffer,200,mapsdirpath
	cmp DWORD [RANInstanceNameBuffer],'NULL'
	    jz .exit

	cinvoke wsprintf,RANBuffer,RESERVE_STRING,ebx

; get "reserved" section for instance

	invoke GetPrivateProfileString,MAIN_SECTION,RANBuffer,NULL_STRING,\
				       RANReserveEntryBuffer,200,mapsdirpath
	cmp DWORD [RANReserveEntryBuffer],'NULL'
	    jnz .usespecificsection

		call GetRandomEntry_RAND
		test eax,eax
		     jz .randomizeloop			; no more available ENTRY sections?
							; (does not quit procedure in case non-random entries present after)

	; print random ENTRY section to RANReserveEntryBuffer (instead of reserved, defined instance)

		cinvoke wsprintf,RANReserveEntryBuffer,ENTRY_STRING,eax

	.usespecificsection:

	call SetRandomLocationFinal

	jmp .randomizeloop

.exit:
ret

;============================================================
ATXPROC GetRandomEntry_RAND			; returns random entry below or equal to [ebp-12]
;============================================================
	cmp DWORD [ebp-4],0
	    jz .none

	push DWORD [ebp-12]
	call GetRandomNumber			; pick an ENTRY section randomly

	mov ecx,[ebp-8] 			; (ENTRY boolean buffer)
	cmp BYTE [eax+ecx-1],0			; has it already been picked?
	    jz .success

; find next unpicked ENTRY section (sequentially)

	.waitforfreeentry:
	cmp eax,[ebp-12]
	    jb .notendoflist

		xor eax,eax

	.notendoflist:
	inc eax
	cmp BYTE [eax+ecx-1],0
	    jnz .waitforfreeentry		; despite appearances, this will never make an endless loop, due
						; to [ebp-4] which is tested earlier (if it is not zero,
						; there is automatically at least one free ENTRY section left)
.success:
	or BYTE [eax+ecx-1],1
	dec DWORD [ebp-4]
ret

.none:
	xor eax,eax				; returns eax=0 if no more available ENTRYs
ret

;============================================================
ATXPROC SetRandomLocationFinal		; section specified at RANReserveEntryBuffer
;============================================================

; RANLocationStrBuffer = "Location#" string INI value

	invoke GetPrivateProfileInt,RANReserveEntryBuffer,ENTRIES_STRING,0,mapsdirpath
	test eax,eax
	     jz .exit

	push eax
	call GetRandomNumber

; get Location# string
	cinvoke wsprintf,RANLocationStrBuffer,LOCATION_STRING,eax

; Get location float values
; RANBuffer -> replaces previous 'Reserve#' string (not value of)

	invoke GetPrivateProfileString,RANReserveEntryBuffer,RANLocationStrBuffer,\
				       NULL_STRING,RANBuffer,200,mapsdirpath
	cmp DWORD [RANBuffer],'NULL'
	    jz .exit

	call GetCurrentInstanceObject
	test eax,eax
	     jz .exit

	mov esi,eax

; SET NEW LOCATION

	mov eax,TempFlyBuffer
	mov edi,RANBuffer
	lea ecx,[eax+4]
	lea edx,[eax+8]

; write first positions values

	cinvoke sscanf,edi,FLOAT_TRIPLET_STR,eax,ecx,edx

	push edi
	push esi
	lea edi,[TempFlyBuffer+0Ch]
	add esi,3Ch
	mov ecx,5
	rep movsd
	pop esi
	pop edi

	mov ecx,esi
	push 0
	mov eax,[ecx]
	push TempFlyBuffer
	call DWORD [eax+38h]			; Teleport dino


; SET OTHER VARIABLES FROM INI LIST FILE - CANIMAL ONLY!!!!!!!

	mov eax,[CANIMAL_VTABLE]
	cmp [esi],eax				; check for CAnimal type
	    jnz .noforceanimalvalues

	invoke GetPrivateProfileFloat,RANReserveEntryBuffer,STAYNEARMAX_STRING,ZERO_STRING,mapsdirpath
	test eax,eax
	     jz @f

		mov edx,[esi+0DCh]		; CBrain
		mov edx,[edx+68h]		; get ActStayNear instance
		mov [edx+64h],eax		; set new StayNearMax value

	@@:

	invoke GetPrivateProfileFloat,RANReserveEntryBuffer,STAYNEAROK_STRING,ZERO_STRING,mapsdirpath
	test eax,eax
	     jz @f

		mov edx,[esi+0DCh]		; CBrain
		mov edx,[edx+68h]		; get ActStayNear instance
		mov [edx+68h],eax		; set new StayNearOK value

	@@:					; 2A68=staynearmax, 2A70=staynearok

	invoke GetPrivateProfileFloat,RANReserveEntryBuffer,WAKEUP_STRING,ZERO_STRING,mapsdirpath
	test eax,eax
	     jz @f

		mov edx,[esi+0DCh]		; CBrain
		mov [edx+340h],eax		; set new WakeUp value

	@@:

	invoke GetPrivateProfileFloat,RANReserveEntryBuffer,SLEEP_STRING,ZERO_STRING,mapsdirpath
	test eax,eax
	     jz @f

		mov edx,[esi+0DCh]		; CBrain
		mov [edx+344h],eax		; set new Sleep value

	@@:

	invoke GetPrivateProfileInt,RANReserveEntryBuffer,NOGETOUT_STRING,0,mapsdirpath
	test eax,eax
	     jz @f

		mov edx,[esi+0DCh]		; CBrain
		mov eax,[edx+7Ch]
		and BYTE [eax+34h],0FBh 	; ActGetOut enable/disable bool

	@@:

	.noforceanimalvalues:

.exit:
ret

;============================================================
ATXPROC GetCurrentInstanceObject		; returns in eax, uses RANInstanceNameBuffer for instance name
;============================================================
; As of ATX 1.50, this proc has been changed to accomodate all Trespasser instances

	mov eax,RANInstanceNameBuffer
	call GetInstanceFromStringGlobal

ret

