;===========================================================
; NIGHT MODE OBJECT TELEPORTATION
;===========================================================

;===========================================================
ATXPROC DoNightModeTeleportsInit
;===========================================================
push ebp
push edi
push esi
push ebx

; get INI filename and path

	mov edi,[mapsdirpathlength]
	mov esi,[LEVELNAME_OBJ] 			; SCN level name
	add edi,mapsdirpath
	mov DWORD [edi],'NMD\'
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'			; modify extension

	mov ebx,1

; check if night mode enabled and set corresponding string in esi

	cmp [NIGHTEnabled],FALSE
	mov esi,NORMALMODELOC_STRING
	    jz @f

		mov esi,NIGHTMODELOC_STRING

	@@:

; main loop

	.nmteleportsloop:

; get current instance name (at stack_ext_buffer+100)

	cinvoke wsprintf,stack_ext_buffer,INSTANCE_STRING,ebx
	invoke GetPrivateProfileString,STRING_GENERAL,stack_ext_buffer,\
				       NONE_STRING,stack_ext_buffer+100,200,mapsdirpath
	cmp DWORD [stack_ext_buffer+100],'none'
	    jz .nmteleportsloopend			; quit if no more instances in order

	cinvoke wsprintf,stack_ext_buffer,esi,ebx

;get location values (at stack_ext_buffer+300)

	invoke GetPrivateProfileString,STRING_GENERAL,stack_ext_buffer,\
				       NONE_STRING,stack_ext_buffer+300,100,mapsdirpath
	cmp DWORD [stack_ext_buffer+300],'none'
	    jz .nolocation

	mov eax,stack_ext_buffer+100
	call GetInstanceFromStringGlobal_CBD
	test eax,eax
	mov edi,eax
	    jz .nolocation

	mov edx,stack_ext_buffer
	xor eax,eax
	lea ecx,[edx+4]
	mov [edx],eax
	mov [edx+4],eax
	mov [edx+8],eax
	lea eax,[edx+8]

	mov ebp,esp
	invoke sscanf,stack_ext_buffer+300,FLOAT_TRIPLET_STR,edx,ecx,eax
	mov esp,ebp

	mov ecx,edi
	mov edi,stack_ext_buffer
	mov eax,[ecx+3Ch]				; keep initial FACING values for object
	mov edx,[ecx+40h]
	mov [edi+0Ch],eax
	mov [edi+10h],edx
	mov eax,[ecx+44h]
	mov edx,[ecx+48h]
	mov [edi+14h],eax
	mov [edi+18h],edx

	push 0
	mov eax,[ecx]
	push edi
	call DWORD [eax+ICInstance.Teleport]		; teleport instance

	.nolocation:

	inc ebx
	    jnz .nmteleportsloop

	.nmteleportsloopend:

pop ebx
pop esi
pop edi
pop ebp
ret
