;============================================================
ATXPROC RainEffectCalcGridSizes 	; ecx = RainEffect struct (modifies struct members)
;============================================================
;cmp [RainFeatureEnabled],0
;jz .exitproc

	fld [ecx+RainEffectBase.Area.XPos]
	fabs
	fst [ecx+RainEffectBase.Area.XPos]
	fst [ecx+RainEffectBase.Area.YPos]
	fchs
	fst [ecx+RainEffectBase.Area.XNeg]
	fstp [ecx+RainEffectBase.Area.YNeg]

	fild [ecx+RainEffect.ParticlesPerDropGroup]
	fsqrt
	frndint
	fist [ecx+RainEffect.GridUnitsPerAxis]
	fdivr [float_one]

	fld [ecx+RainEffect.Area.XPos]
	fsub [ecx+RainEffect.Area.XNeg]
	fmul st0,st1
	fstp [ecx+RainEffect.ParticleGridUnitSizeX]

	fld [ecx+RainEffect.Area.YPos]
	fsub [ecx+RainEffect.Area.YNeg]
	fmulp st1,st0
	fstp [ecx+RainEffect.ParticleGridUnitSizeY]

	fld [ecx+RainEffect.Area.XPos]
	fmul st0,st0
	fstp [ecx+RainEffect.RadiusExp2]

;.exitproc:
ret

;============================================================
ATXPROC RainEffectSetDefaultAsCurrent
;============================================================
;cmp [RainFeatureEnabled],0     ; should always reinit, even if feature disabled, for savegames
;jz .exitproc

       push esi
       push edi

       mov esi,DefaultRainEffect
       mov edi,CurrentRainEffect
       mov ecx,(sizeof.RainEffect)/4
       rep movsd

       pop edi
       pop esi

;.exitproc:
ret

;============================================================
proc RainEffectReadCParticlesFromINI uses esi edi ebx, lpCParticlesStruct, lpININame
;============================================================

	mov esi,[lpININame]
	mov edi,[lpCParticlesStruct]

	mov [edi+CParticles.Type],CPARTICLES_TYPE_FLUID
	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_SOLID,0,esi
	test eax,eax
	     jz @f
	mov [edi+CParticles.Type],CPARTICLES_TYPE_SOLID
	@@:

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_DUST,0,esi
	test eax,eax
	     jz @f
	mov [edi+CParticles.Type],CPARTICLES_TYPE_DUST
	@@:

	mov ebx,00FF0000h
	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_R,0,esi
	shl eax,16
	and ebx,eax

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_G,0,esi
	shl eax,8
	and eax,00FF00h
	or ebx,eax

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_B,0,esi
	and eax,00FFh
	or ebx,eax
	mov [edi+CParticles.ColorRGB],ebx

	xor ebx,ebx
	mov DWORD [edi+CParticles.Flags1],ebx
	mov [edi+CParticles.lpEffectNameDesc],ebx
	mov [edi+CParticles.unknownInt],ebx

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_UNKNOWNFLOAT,0,esi
	and al,1
	mov [edi+CParticles.Flags1],al

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_LOG,0,esi
	and al,1
	mov [edi+CParticles.Log],al

	invoke GetPrivateProfileInt,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_PRIORITY,0,esi
	mov [edi+CParticles.Priority],eax

	invoke GetPrivateProfileFloat,RAINEFFECT_SECTION_CPARTICLES,RAINEFFECT_KEY_UNKNOWNFLOAT,FLOAT_0_25_STR,esi
	mov [edi+CParticles.unknownFloat],eax

	lea eax,[edi+CParticles.Min]
	stdcall RainEffectReadParticleQualitiesFromINI,eax,RAINEFFECT_SECTION_CPARTICLESMIN,esi

	lea eax,[edi+CParticles.Max]
	stdcall RainEffectReadParticleQualitiesFromINI,eax,RAINEFFECT_SECTION_CPARTICLESMAX,esi

ret
endp

;============================================================
proc RainEffectReadParticleQualitiesFromINI uses esi edi ebx, lpParticleQualitiesStruct, lpSectionName, lpININame
;============================================================

	mov esi,[lpININame]
	mov edi,[lpParticleQualitiesStruct]
	mov ebx,[lpSectionName]

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_NUMBER,ZERO_STRING,esi
	mov [edi+CParticleQualities.Number],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_UNKNOWNEULER,ZERO_STRING,esi
	mov [edi+CParticleQualities.unknownRadians],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_SIZE,ZERO_STRING,esi
	mov [edi+CParticleQualities.Size],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_LENGTH,ZERO_STRING,esi
	mov [edi+CParticleQualities.Length],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_VELOCITY,ZERO_STRING,esi
	mov [edi+CParticleQualities.Velocity],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_LIFESPAN,ZERO_STRING,esi
	mov [edi+CParticleQualities.Lifespan],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_STUCKGRAVITY,ZERO_STRING,esi
	mov [edi+CParticleQualities.StuckGravity],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_GRAVITY,ZERO_STRING,esi
	mov [edi+CParticleQualities.Gravity],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_SPREAD,ZERO_STRING,esi
	mov [edi+CParticleQualities.SpreadRadians],eax

	invoke GetPrivateProfileFloat,ebx,RAINEFFECT_KEY_THRESHOLD,ZERO_STRING,esi
	mov [edi+CParticleQualities.Threshold],eax

	fld [edi+CParticleQualities.unknownRadians]
	fmul [pidiv180]
	fstp [edi+CParticleQualities.unknownRadians]

	fld [edi+CParticleQualities.SpreadRadians]
	fmul [pidiv180]
	fstp [edi+CParticleQualities.SpreadRadians]

ret
endp
