;============================================================
ATXPROC RainEffectGenerationRT
;============================================================
push ebp
cmp [RainFeatureEnabled],0
jz .noraineffect

  ; test if interval has elapsed

	invoke GetTickCount
	sub eax,[CurrentRainLastTick]
	cmp eax,[CurrentRainEffect.DropGroupInterval]
	jb .noraineffect

	add [CurrentRainLastTick],eax

  ; get CParticles instance to use to create rain particles

	mov eax,[CurrentRainEffect.EffectNameID]
	test eax,eax
	jnz .effectnamepresent

		mov esi,DefaultRainCParticles
		jmp .raineffectselected

	.effectnamepresent:

	ccall [CParticlesGetObjProc],eax,0
	test eax,eax
	jz .noraineffect

	mov esi,eax

	.raineffectselected:

	GETCPLAYERPRIVINSTANCE ebp

; esi = CParticles instance
; ebp = CPlayerPriv instance

	fld [ebp+CPlayerPriv.Location.X]
	fadd [CurrentRainEffect.Area.XNeg]
	fstp [RE_LastGroupDivisionLocX]
	fld [ebp+CPlayerPriv.Location.Y]
	fadd [CurrentRainEffect.Area.YNeg]
	fst [RE_LastGroupDivisionLocY]
	fstp [RE_FirstGroupDivisionLocY]
	fld [ebp+CPlayerPriv.Location.Z]
	fld st0
	fadd [CurrentRainEffect.Area.ZNeg]
	fstp [RE_CeilingMinZ]
	fadd [CurrentRainEffect.Area.ZPos]
	fstp [RE_CeilingMaxZ]

	mov ebx,[CurrentRainEffect.GridUnitsPerAxis]

	.raindroploopx:

	fld [RE_LastGroupDivisionLocX]
	fadd [CurrentRainEffect.ParticleGridUnitSizeX]
	fstp [RE_TempNextLocX]

	mov edi,[CurrentRainEffect.GridUnitsPerAxis]

		.raindroploopy:

		fld [RE_LastGroupDivisionLocY]
		fadd [CurrentRainEffect.ParticleGridUnitSizeY]
		fstp [RE_TempNextLocY]

		stdcall GetRandomFloatInInterval,RE_FinalDropLoc.X,[RE_LastGroupDivisionLocX],[RE_TempNextLocX]
		stdcall GetRandomFloatInInterval,RE_FinalDropLoc.Y,[RE_LastGroupDivisionLocY],[RE_TempNextLocY]
		stdcall GetRandomFloatInInterval,RE_FinalDropLoc.Z,[RE_CeilingMinZ],[RE_CeilingMaxZ]

		fld [RE_FinalDropLoc.X]
		fsub [ebp+CPlayerPriv.Location.X]
		fmul st0,st0
		fld [RE_FinalDropLoc.Y]
		fsub [ebp+CPlayerPriv.Location.Y]
		fmul st0,st0
		faddp st1,st0
		fcomp [CurrentRainEffect.RadiusExp2]
		fstsw ax
		test ah,FPU_VALUE_BELOW_OR_EQUAL
		jz .locoutsideradius

			mov ecx,esi
			stdcall [CParticlesDoEffectProc],[RE_FinalDropLoc.X],[RE_FinalDropLoc.Y],[RE_FinalDropLoc.Z],\
							 0.000000,0.000000,-1.000000,\	     ; downward vector
							 [CurrentRainEffect.ParticleParam7],[CurrentRainEffect.ParticleThreshold]

		.locoutsideradius:

		mov ecx,[RE_TempNextLocY]
		mov [RE_LastGroupDivisionLocY],ecx
		dec edi
		jnz .raindroploopy

	mov eax,[RE_TempNextLocX]
	mov ecx,[RE_FirstGroupDivisionLocY]
	mov [RE_LastGroupDivisionLocX],eax
	mov [RE_LastGroupDivisionLocY],ecx
	dec ebx
	jnz .raindroploopx

.noraineffect:
pop ebp
ret

;============================================================
;ATXPROC RainEffectNewLoadInit
;============================================================
; not completed

;push ebx
	mov [CurrentRainLastTick],0

;  ; check if atx rain CParticles object is already registered in system
;        ccall [CParticlesEncodeNameProc],RAINEFFECT_DEFAULT_PARTICLES_NAME
;        mov ebx,eax
;        ccall [CParticlesGetObjProc],eax,0
;        test eax,eax
;             jnz @f      ; error: returns default object if not found, not null!
;  ; register if not
;        mov ecx,DefaultRainCParticles
;        stdcall CParticlesAllocAndAssignID,ebx
;        @@:

;pop ebx
;ret


