;=======================================================
INTERCEPTPROC SMKNEXTFRAMEINTERCEPT
;=======================================================
; no essential replaced code
; ebp = CVideoWnd object

	stdcall SMKProcessNextFrameEffects,ebp

ret			; simple return works here; no code flow alterations to intercept point

;=======================================================
INTERCEPTPROC SMKLASTFRAMEINTERCEPT		    ; eax, ecx, edx may be destroyed
;=======================================================

	DDSURFACERELEASE [SMKEffects_lpDDSurfaceTemp]
	mov [SMKEffects_lpDDSurfaceTemp],0


   ; /* REPLACED CODE

	mov al,[ebp+154h]

   ; */
ret			; simple return works here; no code flow alterations to intercept point


;=======================================================
proc SMKProcessNextFrameEffects uses ebx edi esi, lpCVideoWnd
;=======================================================

; local vars:
; esi = temporary off-screen DD surface
; edi = real on-screen DD surface
; ebx = pointer to storage for current DD surface

local RasterWinRect : RECT

	test [SMKEffects_BlitEffects],SMKEFFECTS_FLAGS_RESIZE	; is there at least one effect being applied to smk?
	jz .noeffects


   ; get current video window resolution
	GETMAINCRASTERWININSTANCE ecx
	mov [RasterWinRect.left],0
	mov eax,[ecx+08h]
	mov [RasterWinRect.top],0
	mov edx,[ecx+0Ch]
	mov [RasterWinRect.right],eax
	mov [RasterWinRect.bottom],edx

	cmp eax,640
	jnz @f
	cmp edx,480
	jz .noeffects

	@@:



   ; get pointer to storage for current DD surface
	GETTRESSURFACEOBJSECONDSURFACEADDR ebx

   ; get real on-screen DD surface
	mov edi,[ebx]			; save real DD surface

   ; create temporary off-screen DD surface if we don't have one already
	mov esi,[SMKEffects_lpDDSurfaceTemp]
	test esi,esi
	jnz @f

		stdcall DDCreateOffscreenCloneSurface,edi,640,480
		test eax,eax
		jz .allocerror

		mov [SMKEffects_lpDDSurfaceTemp],eax
		mov esi,eax

		stdcall DDColorFillSurface,esi,0

	@@:


   ; swap primary DirectDraw surface pointer that Trespasser uses with pointer to temp off-screen surface
	mov [ebx],esi

   ; continue with call to draw next frame (will draw to temporary off-screen surface now)

   ; /* REPLACED CODE
	mov ecx,[lpCVideoWnd]
	call [CVIDEOWND_DRAWNEXTFRAMEPROC]
   ; */


   ; swap temp off-screen surface pointer back with primary surface pointer for Tres
	mov [ebx],edi


   ; blit off-screen surface to primary surface using whatever effects are enabled
   ; here, we need to specify the game window resolution (in some cases, this is different from screen resolution)

	lea edx,[RasterWinRect]
	stdcall DDSurfaceBlit,esi,edi,0,edx

   ; exit

ret

.noeffects:

   ; /* REPLACED CODE
	mov ecx,[lpCVideoWnd]
	call [CVIDEOWND_DRAWNEXTFRAMEPROC]
   ; */

ret


.allocerror:	; ecx = DD error code

	cinvoke sprintf,stack_ext_buffer,SMKEFFECTS_ALLOCERROR,ecx
	stdcall WriteLogFileInGame,stack_ext_buffer,eax

   ; /* REPLACED CODE
	mov ecx,[lpCVideoWnd]
	call [CVIDEOWND_DRAWNEXTFRAMEPROC]
   ; */

ret

endp







