;============================================================
INTERCEPTPROC ACTBITEINTERCEPT				; ecx = ActBite instance
;============================================================
; ActBite code intercept - eax and edx may be destroyed, must save ecx and others
; IMPORTANT NOTE!!!!!!
; This code is also called upon the "Feint" AI behavior;
; differentiation between the two acts must be done by
; verifying the object passed in ecx (VTable or signature)

; differentiate between ActBite and ActFeint via class signature

	cmp DWORD [ecx+4Ch],'Bite'
	    jnz .exit

; here, CInfluence object pointer is stored at DWORD [esp+0Ch]
; -> load into eax for callbacks

	mov eax,[esp+0Ch]

; /* CALLBACKS

      ; callback functions must call GetCurrentOnActBiteAnimalInfo to retrieve
      ; /*
	mov [CurrentOnActBiteParentInstanceInfo],ONACTBITE_NO_CANIMAL_INFO
      ; */

	mov edx,[eax+CInfluence.lpSourceInstance]

      ; callback functions can read directly
      ; /*
	mov [CurrentOnActBiteInstance],ecx
	mov [CurrentOnActBiteInfluence],eax
	mov [CurrentOnActBiteTargetBiteInstance],edx
      ; */

	PLUGINSCBINVOKE PLUGIN_CALLBACKS.OnActBite,[CurrentOnActBiteInstance],\
			    [CurrentOnActBiteTargetBiteInstance],[CurrentOnActBiteInfluence]

	BBMCALLINV ACTJUMPNEW_MAIN,[UseDisableActJumpNew]
	BBMCALL SpitterCode_RT,[AnimalProjectileBuffer]
	BBMCALL MXTOnActBiteRT,[UseMXTOnActBite]


	mov ecx,[CurrentOnActBiteInstance]		; restore ecx

	xor eax,eax					; reset variables to NULL (preventative)
	mov [CurrentOnActBiteInstance],eax
	mov [CurrentOnActBiteInfluence],eax
	mov [CurrentOnActBiteTargetBiteInstance],eax

	mov [CurrentOnActBiteParentInstanceInfo],eax	; will return null if called at wrong time

; */

.exit:
pop eax 						; get return address
sub esp,138h						; replaced code
jmp eax 						; back to normal biting code
