;===========================================================
;MAIN MOUSE MVT INTERCEPT CODE AND HANDLER (IN-GAME ONLY)
;===========================================================
; -> May not include ALL in-game mouse movement, only some feature-specific.

; Upon call to GETCURSORPOSINTERCEPT, must preserve registers
; accord to C calling standards, and must pass DWORD [esp+4]
; to GetCursorPos to retrieve standard values and return.
; Here, ebx points to GetAsyncKeyState call and esi points
; to mouse data class/structure.
; To remove mouse mvt from standard game controls,
; put DWORD [esi+28h] in DWORD [(DWORD [esp+4])] and
; DWORD [esi+2Ch] in DWORD [(DWORD [esp+4])+4], where
; (DWORD [esp+4]) holds POINT structure.
; [esi+28h] = last X POINT value
; [esi+2Ch] = last Y POINT value
; Although unused by game, should always return 0000001 in eax
; if skipping GetCursorPos call.

;===========================================================
INTERCEPTPROC GETCURSORPOSINTERCEPT
;===========================================================

	cmp [DisableInGameMouseMvt],0
	mov edx,[esp+4] 			; pointer to POINT struc for GetCursorPos
	    jnz .nomousemvt

	push edx
	call [GetCursorPos]

ret 4

.nomousemvt:

	mov eax,[esi+28h]
	mov ecx,[esi+2Ch]
	mov [edx],eax
	mov [edx+4],ecx

; POINT structure at (esi+28h) = mouse coordinates

	BBMCALL DoFollowDinoRTMouseMvtHandler,[FDEnabled]

	mov eax,1

ret 4

