;====================================================================
; NEW BACKGROUND IMAGE LOADER
;====================================================================
; all registers except edx must be preserved if no new TGA file to set
; eax = GetFileAttributes param (string)
; ecx = string length

; note: the index used to reference the "li_levelname" TGA filenames
; internally by the EXE is found at DWORD [esp+0Ch] upon call to this proc.
; A value of 00000009 indicates the default TGA file (lower indexes determine
; the default level TGA files).

;====================================================================
INTERCEPTPROC LEVELLOADBG	; return address at [esp+124h] (including call to this proc)
;====================================================================

	mov edx,[esp+124h]
	cmp edx,[LOADBGFILE_RET_ADDR]
	    jnz .exit

push edi
	mov edi,[mapsdirpathlength]
push esi
	add edi,mapsdirpath
	mov esi,[LEVELNAME_OBJ]
	mov DWORD [edi],LEVEL_LOAD_BACKGROUND_MAPS_DIR
push ebx
	add edi,4
push ecx
push eax

	mov ebx,edi
	call TransferString
	mov DWORD [edi-4],LEVEL_LOAD_BACKGROUND_EXTENSION

	mov esi,mapsdirpath
	invoke FindFirstFile,esi,find_data_buf

	cmp eax,INVALID_HANDLE_VALUE		; does LEVELNAME.tga exist in 'MAPS\LBG\' ?
	    jnz .found

	    cmp DWORD [esp+20h],00000009	; default default image? (intentional repetition)
		jnz .previousonly

	    mov DWORD [ebx],'defa'
	    mov DWORD [ebx+4],'ult.'
	    mov DWORD [ebx+8],00616774h 	; 'tga' + null terminator

	    invoke FindFirstFile,esi,find_data_buf
	    cmp eax,INVALID_HANDLE_VALUE
		jz .previousonly

	.found:

	invoke FindClose,eax

						; esi = mapsdirpath
	mov edi,[esp]				; set new TGA file as background file (in local mem)
	call TransferString

pop eax
pop ecx
pop ebx
pop esi
pop edi

mov edx,[esp]
mov [esp],eax					; GetFileAttributes param
jmp edx

.previousonly:
pop eax
pop ecx
pop ebx
pop esi
pop edi

.exit:
mov edx,[esp]					; return address

;/* REPLACED CODE
and ecx,3
mov [esp],eax					; GetFileAttributes param
repz movsb
;*/

jmp edx







