;============================================================
ATXPROC GetInstancePhysicsVelocity
;============================================================
; includes rotation speed
; unlike EXE, returns TRUE if object is active and NULL if
; default values were returned.

; param1 = pointer to buffer for result
; param2 = CInstance

	mov ecx,[esp+8]

    ;    GETINSTANCEPHYSICSINFO ecx,ecx

	call GetInstanceBaseVelocityPointer
	cmp eax,VELOCITY_POINTER_INVALID
	    jz .objectidle

	push edi
	push esi
	mov edi,[esp+12]
	lea esi,[eax+4]
	mov ecx,7

	.setvelocityloop:
	mov eax,[esi]
	mov [edi],eax
	add esi,0Ch
	add edi,4					; 7 values are at 0Ch intervals
	loop .setvelocityloop

	pop esi
	pop edi

mov eax,1
ret 8

.objectidle:

	push edi
	mov edi,[esp+8]
	mov eax,0.000000				; same as EXE, but assigns 0.000000 instead of
	mov ecx,7					; 1.000000 to Wquat velocity value *
	rep stosd
	mov edx,[esp+8]
	pop edi

	;mov DWORD [edx+12],1.000000

xor eax,eax
ret 8

; * Theoretically, the value 1.000000 should be the correct one,
; because it is part of the zero-rotation local quaternion (includingcosine of 0). However,
; due to the way the values are set when an object is first moved
; from a frozen state, it must be set to 0.000000 to avoid giving
; the object an initial rotation, despite possibly inexact math.

;============================================================
ATXPROC SetInstancePhysicsUnfreezeOnly
;============================================================
; param1 = CInstance

	mov eax,[esp+4]

	GETINSTANCEPHYSICSINFO ecx,eax

	push [SETOBJPHYSICSOBJPARAM]
	mov edx,[ecx]
	push 0
	push eax
	call DWORD [edx+18h]				; unfreeze object/enable object physics

ret 4

;============================================================
ATXPROC SetInstancePhysicsVelocity
;============================================================
; includes rotation speed
; This is same as the [+44h] method used by ActionType 10 to set [X,Y,Z]
; velocity, except will also set quaternion rotation velocity.
; [esp+4] = instance (CInstance)
; [esp+8] = address of 7 velocity values
; ecx = physics sub-instance of instance [[instance+28h]+0Ch]
; Note: The DEMO executable finds the base address of the velocity
;       using different calculations than the full-version 1.1 EXEs.

push edi
push esi

	mov edi,[esp+0Ch]

	GETINSTANCEPHYSICSINFO ecx,edi

	push [SETOBJPHYSICSOBJPARAM]
	mov edx,[ecx]
	push 0
	push edi
	call DWORD [edx+18h]				; unfreeze object/enable object physics

	mov ecx,edi
	call GetInstanceBaseVelocityPointer
	cmp eax,VELOCITY_POINTER_INVALID
	    jz .exit

	mov esi,[esp+16]
	lea edi,[eax+4]
	mov ecx,7

	.getvelocityloop:
	mov eax,[esi]
	mov [edi],eax
	add esi,4
	add edi,0Ch					; 7 values are at 0Ch intervals
	loop .getvelocityloop

.exit:
pop esi
pop edi
ret 8

;============================================================
ATXPROC GetInstanceBaseVelocityPointer			; ecx = CInstance (not CPhysicsInfo)
;============================================================
; returns pointer or VELOCITY_POINTER_INVALID if not found/object idle/error

	GETINSTANCEPHYSICSINDEX ecx
	test eax,eax
	     jl .objectidle

	ADJUSTVELOCITYPOINTER

ret

.objectidle:

	mov eax,VELOCITY_POINTER_INVALID

ret





