;===========================================================
ATXPROC DoRayCastAimdotUpdate
;===========================================================

	mov [THIRDPAIMAimdotLastObj],0
	mov edi,stack_ext_buffer

; check if player is holding gun, and if so, get instance

	mov ecx,GETWEAPON_PRIMARY
	call GetHeldWeaponInstance
	test eax,eax
	mov esi,eax
	    jz .exit

; esi = CGun object

; get starting location for raycast
; This is basically copied from the executable for consistency.
; The game uses the CONVERT_TO_FACING proc with "base vector"
; different from [0.0, 1.0, 0.0]. Could not figure out why.
; "base vector" is gotten directly from CGun object.
; The game also treats quaternion W value 1.00000 differently.
; Must be a "key" value. Don't know if this is required or if is
; for optimization.

	mov eax,[esi+3Ch]					; keep same orientation as gun
	mov edx,[esi+40h]
	mov [RayCastSourceQuatW],eax
	mov [RayCastSourceQuatX],edx
	mov eax,[esi+44h]
	mov edx,[esi+48h]
	mov [RayCastSourceQuatY],eax
	mov [RayCastSourceQuatZ],edx

	fld [RayCastSourceQuatW]
	fcomp [float_one]
	fstsw ax
	test ah,40h						; if Quat.W is equal to 1.000000, use vector alone
	     jne .usevector

	     lea eax,[esi+74h]					; "base vector"
	     lea edx,[RayCastTempVectorX]			; destination
	     lea ecx,[RayCastSourceQuatW]
	     stdcall [PTRCONVERT_TO_FACING_PROC_2A],edx,eax
	jmp .skipvector

	.usevector:
	     mov eax,[esi+74h]
	     mov ecx,[esi+78h]
	     mov edx,[esi+7Ch]
	     mov [RayCastTempVectorX],eax
	     mov [RayCastTempVectorY],ecx
	     mov [RayCastTempVectorZ],edx
	.skipvector:

	fld DWORD [esi+4Ch]					; length value in CGun object (?)
	fld [RayCastTempVectorX]
	fmul st0,st1
	fld [RayCastTempVectorY]
	fmul st0,st2
	fld [RayCastTempVectorZ]
	fmul st0,st3
	fadd DWORD [esi+CInstance.Location.Z]
	fst [THIRDPAIMAimdotSourceZ]
	fstp [RayCastSourcePosZ]				; store starting position for ray cast
	fadd DWORD [esi+CInstance.Location.Y]
	fst [THIRDPAIMAimdotSourceY]
	fstp [RayCastSourcePosY]
	fadd DWORD [esi+CInstance.Location.X]
	fst [THIRDPAIMAimdotSourceX]
	fstp [RayCastSourcePosX]
	fstp st0

	mov eax,[esi+4Ch]
	mov [RayCastUnknownParam],eax

	lea ecx,[RayCastPrivateStrucPointerHold]
	push DWORD [esi+50h]					; gun Range value
	push RAYCAST_DEFAULT_MIN_INTERSECT_DISTANCE
	push edi
	call [RayCastProcGetIntersect]

	.getnextintersect:
	lea ecx,[RayCastPrivateStrucPointerHold]
	call [RayCastProcGetPrivate]
	test eax,eax
	     jz .exitfree					; did we have an intersect? (can be more than one in structure; RayCastProcGetPrivate should return first found)
	mov ecx,[eax+20h]
	cmp ecx,esi
	    jz .getnextintersect				; did we hit same CGun instance? If so, try next intersect

	mov [THIRDPAIMAimdotLastObj],ecx
	mov ebx,[eax]
	mov ecx,[eax+4]
	mov edx,[eax+8]
	mov [THIRDPAIMAimdotLastX],ebx
	mov [THIRDPAIMAimdotLastY],ecx
	mov [THIRDPAIMAimdotLastZ],edx

.exitfree:

	lea ecx,[RayCastPrivateStrucPointerHold]
	call [RayCastProcFree]

.exit:
ret
