;============================================================
ATXPROC ResetCCameraPlayerSources
;============================================================

	GETCCAMERAINSTANCE ecx
	GETCPLAYERPRIVINSTANCE eax
	mov [ecx+50h],eax
	mov [ecx+54h],eax

ret

;============================================================
ATXPROC CCameraTeleport 			; edx = pointer to 3 location values (y,x,z) and 4 quat values (w,x,y,z)
;============================================================
; destroyed: eax,ecx,edx
; If members DWORD [CCamera+50h] and DWORD [CCamera+54h] are CPlayerPriv objects,
; the player object will be teleported along with the camera.

	GETCCAMERAINSTANCE ecx

	push 0
	mov eax,[ecx]
	push edx
	call DWORD [eax+ICInstance.Teleport]	; set new camera position/orientation

ret

;============================================================
ATXPROC Convert3DPixelTo2DRender
;============================================================
; ecx = pointer to 3 floats
; edx = pointer for 2 int return values (x and y positions)
;       and 1 float for 1/z value
; NOTE: These calculations are basically copied from the Trespasser
; executable (not within a usable function). They are basically
; "black-box" calculations and implicitly calculate screen positions,
; taking into account screen resolution and size. They depend on a
; call to a CCamera method, which returns values used in a dot-product
; -style calculation.
; this function explicitly returns values that take into account
; screen offset caused by screen size change.
; takes care of screen resolution checks
; returns in eax:
; 1 if within screen
; 0 if not within screen (or if behind screen)

push ebp
mov ebp,esp
sub esp,(12*4)
push edi
push esi
push ebx

	mov eax,[DDSURFACE_BASE_ADDR]
	mov edi,edx
	mov esi,ecx
	mov ebx,[eax]

	GETCCAMERAINSTANCE ecx

	lea edx,[ebp-(12*4)]
	push edx
	call [GetCam2DRenderValuesProc]

; calculate depth of point and check if behind screen

	fld [cam3]
	fmul DWORD [esi]
	fld [cam6]
	fmul DWORD [esi+4]
	fld [cam9]
	fmul DWORD [esi+8]
	faddp st1,st0
	faddp st1,st0
	fadd [cam12]

	fst DWORD [edi+8]

	fcomp [CAM2D_DEPTH_CHECK]		; is z below minimum? (typical min = 1.00000)
	fstsw ax
	test ah,01h
	     jnz .outofscreen

	fld DWORD [edi+8]
	fdivr [float_one]			; get 1/z and store temporarily
	fstp DWORD [edi+8]

; calculate y value (height) and check if inside limits
; (this is independant of resolution)

	fld [cam2]
	fmul DWORD [esi]
	fld [cam5]
	fmul DWORD [esi+4]
	fld [cam8]
	fmul DWORD [esi+8]
	faddp st1,st0
	faddp st1,st0
	fadd [cam11]

	fmul DWORD [edi+8]			; y/z
	fst DWORD [edi+4]

	fcomp [CAM2D_MINHW_CHECK]
	fstsw ax
	test ah,01h
	     jnz .outofscreen

	fld DWORD [edi+4]
	fcomp [CAM2D_MAXHW_CHECK]
	fstsw ax
	test ah,41h
	     jz .outofscreen

; calculate x value (width)

	fld [cam1]
	fmul DWORD [esi]
	fld [cam4]
	fmul DWORD [esi+4]
	fld [cam7]
	fmul DWORD [esi+8]
	faddp st1,st0
	faddp st1,st0
	fadd [cam10]

	fmul DWORD [edi+8]			; x/z
	fst DWORD [edi]

	fcomp [CAM2D_MINHW_CHECK]
	fstsw ax
	test ah,01h
	     jnz .outofscreen

	fld DWORD [edi]
	fcomp [CAM2D_MAXHW_CHECK]
	fstsw ax
	test ah,41h
	     jz .outofscreen

; from here on, it is assumed pixel is within screen limits
; and get final screen coordinates

	fld DWORD [edi]
	fistp DWORD [edi]
	fld DWORD [edi+4]
	fistp DWORD [edi+4]

	mov ecx,[edi]
	mov edx,[edi+4]

	cmp ecx,0
	    jl .outofscreen
	cmp edx,0
	    jl .outofscreen
	cmp ecx,[ebx+8] 			; x res
	    jnb .outofscreen
	cmp edx,[ebx+12]			; y res
	    jnb .outofscreen

	add ecx,[ebx+88h]			; x window offset
	add edx,[ebx+8Ch]			; y window offset
	mov [edi],ecx
	mov [edi+4],edx

	mov eax,1

pop ebx
pop esi
pop edi
mov esp,ebp
pop ebp
ret

.outofscreen:
	xor eax,eax
pop ebx
pop esi
pop edi
mov esp,ebp
pop ebp
ret

;=========================================================
ATXPROC AdjustCameraFOVWidescreen
;=========================================================

	mov eax,[AT06CameraFOVValue]
	mov ecx,RenderTempObj2
	test eax,eax
	     jz .noadjust

		mov [ecx+10h],eax
		mov eax,[CSETRENDERERACTIONVTABLE]
		mov DWORD [ecx+4h],0
		mov DWORD [ecx+8h],2
		mov [ecx],eax
		call DWORD [eax+8]

.noadjust:
ret
