;============================================================
ATXPROC FindNextSaveGameFileName	; [esp+4] = buffer in which to return (should be min. 16 bytes)
;============================================================
; if error, first character in buffer will be null
; destroyed: eax,ecx,edx

push ebx
push edi
push esi

	mov ecx,[gamedirpathlength]
	mov esi,gamedirpath_const
	mov edi,FindNextSGFNBuffer
	rep movsb
	mov DWORD [edi],'SAVE'
	mov DWORD [edi+4],'GAME'
	mov BYTE [edi+8],'.'
	add edi,9

	mov esi,[esp+4+12]
	xor ebx,ebx
	mov BYTE [esi],0

	.mainloop:
	cinvoke wsprintf,edi,FIND_NEXT_SAVEGAME_NAME_STR,ebx

	invoke FindFirstFile,FindNextSGFNBuffer,FindNextSGFNData
	cmp eax,INVALID_HANDLE_VALUE
	    jz .namefound

	invoke FindClose,eax

	inc ebx
	cmp ebx,1000
	    jb .mainloop

	xor eax,eax

pop esi
pop edi
pop ebx
ret 4

.namefound:

	 mov edx,[edi]				; savegame extension + null-terminator
	 mov DWORD [esi],'SAVE'
	 mov DWORD [esi+4],'GAME'
	 mov BYTE [esi+8],'.'
	 mov [esi+9],edx

	 mov eax,TRUE

pop esi
pop edi
pop ebx
ret 4

;============================================================
ATXPROC IsLevelSavedGame			; returns 0 if false, non-zero if true
;============================================================
; NOTE: If a Level Restart was performed before last load,
;       automatically NOT a saved game.

cmp [Restart_Exit_Level_BOOL],FALSE
jz @f
	xor eax,eax
	ret
@@:

push edi
push ecx
push esi
push edx

	or ecx,0FFFFFFFFh
	mov edi,[LEVELNAME_OBJ]
	add edi,20
	xor eax,eax
	mov edx,edi
	repnz scasb

	lea ecx,[edi-(SAVEGAME_DEFAULT_EXTENSION.size+1)]
	cmp ecx,edx
	    jnb .extcheck

		xor eax,eax
		jmp .exitproc

	.extcheck:

	mov edx,SAVEGAME_DEFAULT_EXTENSION
	call CompareStrings
	xor eax,TRUE

.exitproc:
pop edx
pop esi
pop ecx
pop edi
ret

;============================================================
ATXPROC IsLevelSavedGameAbsolute		; returns 0 if false, non-zero if true
;============================================================
; NOTE: Does not take into account level restarts
;       (source *.scn or savegame name only)

push edi
push ecx
push esi

	or ecx,0FFFFFFFFh
	mov edi,[LEVELNAME_OBJ]
	add edi,20
	xor eax,eax
	repnz scasb

	cmp DWORD [edi-5],'.SCN'
	    jz .notsavedgameabs
	cmp DWORD [edi-5],'.scn'
	    jz .notsavedgameabs
	or al,1
	.notsavedgameabs:

pop esi
pop ecx
pop edi
ret
