;============================================================
ATXPROC DoAT10JUMPMainEmulInit
;============================================================
; Note: jump info for instances stored in the jump data buffer
; follow the same instance order as the CAnimalBuffer.
; Jump data buffer is kept separate in case user wants to
; disable it and save a few kilobytes or less of memory.

push ebp
push ebx
push esi
push edi

	LOCALRELEASE [CAnimalJumpInfoBuf]
	mov [BUFSIZECAnimalJump],0

	cmp [UseDisableActJumpNew],0
	    jnz .exit
	cmp [CAnimalBuffer],0
	    jz .exit

	call GetCAnimalInstanceCount
	mov ecx,sizeof.CANIMAL_JUMP_INFO
	mul ecx
	push eax
	invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	pop ecx
	     jz .exit
	mov [BUFSIZECAnimalJump],ecx
	mov [CAnimalJumpInfoBuf],eax

	mov esi,[LEVELNAME_OBJ] 				; SCN level name
	mov edi,mapsdirpath
	add edi,[mapsdirpathlength]
	mov DWORD [edi],'JMP\'					; 'JMP\' folder for jump data
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'				; modify extension

	invoke GetPrivateProfileString,STRING_GENERAL,STRING_PUSH,PushINIdef,PushDefault,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_JUMPANGLE,JumpAngleINIdef,JumpAngleDefault,50,mapsdirpath
	invoke GetPrivateProfileInt,STRING_GENERAL,STRING_JUMPTENDANCY,[JumpTendancyINIdef],mapsdirpath
	mov [JumpTendancyDefault],eax
	invoke GetPrivateProfileInt,STRING_GENERAL,STRING_REPEATPERIOD,-1,mapsdirpath
	mov [RepeatPeriodDefault],eax
	mov ebx,eax
	invoke GetPrivateProfileInt,STRING_GENERAL,STRING_TENDANCYCHECKPERIOD,-1,mapsdirpath
	cmp ebx,-1						; is RepeatPeriod present?
	mov ecx,ebx						; if RepeatPeriod is present, then it becomes default value for TendancyCheckPeriod unless TendancyCheckPeriod is present (checked later)
	    jnz @f

		mov edx,[RepeatPeriodINIdef]
		mov ecx,[TendancyCheckPeriodINIdef]		; if RepeatPeriod is absent, use ATXconfig.ini default for TendancyCheckPeriod (if this one is not present)
		mov [RepeatPeriodDefault],edx

	@@:

	cmp eax,-1						; is TendancyCheckPeriod present?
	    jnz @f

		mov eax,ecx					; if not, used previously-defined default

	@@:
	mov [TendancyCheckPeriodDefault],eax

; extra jump condition values (ATX 1.61+)

	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MAXBODYTARGETDIRANGLE ,MaxBodyTargetDirAngleINIdef ,MaxBodyTargetDirAngleDefault ,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MAXHEADTARGETDIRANGLE ,MaxHeadTargetDirAngleINIdef ,MaxHeadTargetDirAngleDefault ,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MINTOTALVELOCITY	   ,MinTotalVelocityINIdef	,MinTotalVelocityDefault      ,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MINDIRECTIONALVELOCITY,MinDirectionalVelocityINIdef,MinDirectionalVelocityDefault,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MAXDIRVELOCITYANGLE   ,MaxDirVelocityAngleINIdef	,MaxDirVelocityAngleDefault   ,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MINTARGETDISTANCE	   ,MinTargetDistanceINIdef	,MinTargetDistanceDefault     ,50,mapsdirpath
	invoke GetPrivateProfileString,STRING_GENERAL,STRING_MAXTARGETDISTANCE	   ,MaxTargetDistanceINIdef	,MaxTargetDistanceDefault     ,50,mapsdirpath

; MAIN JUMP VALUES SCAN LOOP

	mov ebp,[CAnimalJumpInfoBuf]
	mov ebx,[CAnimalBuffer]

.getjumpvalueloop:

	mov eax,[ebx+CANIMAL_INFO.Instance]
	mov edx,[eax+0DCh]					; CBrain
	lea esi,[edx+220h]					; esi=pointer to instance/section name

	mov [ebp+CANIMAL_JUMP_INFO.Flags],0

	invoke GetPrivateProfileFloat,esi,STRING_PUSH,PushDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.Push],eax

	invoke GetPrivateProfileFloat,esi,STRING_JUMPANGLE,JumpAngleDefault,mapsdirpath
	push eax
	fld DWORD [esp]
	fmul [pidiv180] 					; convert angle to radians
	fstp [ebp+CANIMAL_JUMP_INFO.JumpAngle]
	add esp,4

	invoke GetPrivateProfileInt,esi,STRING_JUMPTENDANCY,[JumpTendancyDefault],mapsdirpath
       ;------------
       ; NO JUMPING FOR QUADRUPEDS SETTING (applied via eax)
       ;------------
	cmp [UseDisableQuadrupedJumps],FALSE
	    jz @f
	    mov edx,[ebx+CANIMAL_INFO.Instance]
	    mov ecx,[edx+28h]					; CInfo class
	    mov edx,[ecx+0Ch]					; physics class
	    mov ecx,[edx]					; physics class VTable
	    cmp ecx,[PHINFOQUADRUPEDVTABLE]			; is quadruped?
		jnz @f
		xor eax,eax					; if so, set jump tendancy to null
	@@:
       ;------------
	mov [ebp+CANIMAL_JUMP_INFO.JumpTendancy],eax

	invoke GetPrivateProfileInt,esi,STRING_REPEATPERIOD,-1,mapsdirpath
	mov ecx,eax
	mov edx,eax
	cmp eax,-1
	    jnz @f
	    mov ecx,[RepeatPeriodDefault]
	    mov edx,[TendancyCheckPeriodDefault]
	@@:
	mov [ebp+CANIMAL_JUMP_INFO.RepeatPeriod],ecx
	mov [ebp+CANIMAL_JUMP_INFO.LastTickCount],0

	invoke GetPrivateProfileInt,esi,STRING_TENDANCYCHECKPERIOD,edx,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.TendancyCheckPeriod],eax
	mov [ebp+CANIMAL_JUMP_INFO.TendancyCheck_LastTick],0

; extra jump condition values (ATX 1.61+)

	invoke GetPrivateProfileFloat,esi,STRING_MAXBODYTARGETDIRANGLE,MaxBodyTargetDirAngleDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MaxBodyAngleWithTarget],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXBODYANGLE
	fld DWORD [ebp+CANIMAL_JUMP_INFO.MaxBodyAngleWithTarget]
	fmul [pidiv180]
	fcos
	fstp [ebp+CANIMAL_JUMP_INFO.MaxBodyAngleWithTarget]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MAXHEADTARGETDIRANGLE,MaxHeadTargetDirAngleDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MaxHeadAngleWithTarget],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXHEADANGLE
	fld [ebp+CANIMAL_JUMP_INFO.MaxHeadAngleWithTarget]
	fmul [pidiv180]
	fcos
	fstp [ebp+CANIMAL_JUMP_INFO.MaxHeadAngleWithTarget]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MINTOTALVELOCITY,MinTotalVelocityDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MinTotalVelocity],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINTOTALSPEED
	fld [ebp+CANIMAL_JUMP_INFO.MinTotalVelocity]
	fmul st0,st0
	fstp [ebp+CANIMAL_JUMP_INFO.MinTotalVelocity]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MINDIRECTIONALVELOCITY,MinDirectionalVelocityDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MinVelocityDirectional],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINDIRSPEED
	;fld [ebp+CANIMAL_JUMP_INFO.MinVelocityDirectional]     ; NOT ^2
	;fmul st0,st0
	;fstp [ebp+CANIMAL_JUMP_INFO.MinVelocityDirectional]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MAXDIRVELOCITYANGLE,MaxDirVelocityAngleDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MaxVelocityDirAngle],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXDIRANGLE
	fld [ebp+CANIMAL_JUMP_INFO.MaxVelocityDirAngle]
	fmul [pidiv180]
	fcos
	fstp [ebp+CANIMAL_JUMP_INFO.MaxVelocityDirAngle]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MINTARGETDISTANCE,MinTargetDistanceDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MinTargetDistance],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINDISTANCE
	fld [ebp+CANIMAL_JUMP_INFO.MinTargetDistance]
	fmul st0,st0
	fstp [ebp+CANIMAL_JUMP_INFO.MinTargetDistance]
	@@:

	invoke GetPrivateProfileFloat,esi,STRING_MAXTARGETDISTANCE,MaxTargetDistanceDefault,mapsdirpath
	mov [ebp+CANIMAL_JUMP_INFO.MaxTargetDistance],eax
	test eax,eax
	     jz @f
	or [ebp+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXDISTANCE
	fld [ebp+CANIMAL_JUMP_INFO.MaxTargetDistance]
	fmul st0,st0
	fstp [ebp+CANIMAL_JUMP_INFO.MaxTargetDistance]
	@@:

	add ebp,sizeof.CANIMAL_JUMP_INFO
	add ebx,sizeof.CANIMAL_INFO
	cmp ebx,[CAnimalBufferEnd]
	    jb .getjumpvalueloop

	call RANDOMIZE_RANDOM_PROC				; seed randomized value in advance

.exit:
pop edi
pop esi
pop ebx
pop ebp
ret

;============================================================
ATXPROC ACTJUMPNEW_MAIN
;============================================================
; AT10 object (64 bytes, also add 16 unknown bytes for 'safety'):
; [AT10+00h]      = VTable
; [AT10+00h]      = n/a (set to 0)
; BYTE [AT10+14h] = "Frozen" bool
; [AT10+18h]      = "Target" object
; BYTE [AT10+1Ch] = "Impulse" bool
; [AT10+38h]      = "Push" float
; [AT10+3Ch]      = "Emitter" object
; Note: the Emitter object here uses a CAnimal-type VTable. Only
; its standard methods are used (for all objects), so it will always work
; even though the Emitter is not of CAnimal type class.

cmp [CAnimalJumpInfoBuf],0
    jz .preexit

push ebp
push edi
push esi
push ebx

	call GetCurrentOnActBiteAnimalInfo
	test eax,eax
	     jz .exit

	mov esi,[eax+CANIMAL_INFO.Instance]
	mov ecx,[eax+CANIMAL_INFO.Index]
	mov eax,sizeof.CANIMAL_JUMP_INFO
	mov ebx,[CAnimalJumpInfoBuf]

	mul ecx
	add ebx,eax

	mov ebp,[CurrentOnActBiteTargetBiteInstance]		; ebp = target instance for bite

;-------------------------------------
;INTERVAL CODE
;-------------------------------------
; ebx = dino's jump info, esi = dino object

; ensure interval has elapsed (RepeatPeriod)
	invoke GetTickCount
	mov edi,eax
	sub eax,[ebx+CANIMAL_JUMP_INFO.LastTickCount]
	cmp eax,[ebx+CANIMAL_JUMP_INFO.RepeatPeriod]
	    jb .exit

; ensure interval has elapsed (TendancyCheckPeriod)
	mov eax,edi
	sub eax,[ebx+CANIMAL_JUMP_INFO.TendancyCheck_LastTick]
	cmp eax,[ebx+CANIMAL_JUMP_INFO.TendancyCheckPeriod]
	    jb .exit
	mov [ebx+CANIMAL_JUMP_INFO.TendancyCheck_LastTick],edi

; determine if dino is to jump or not (randomly, based on JumpTendancy value)

	stdcall GetRandomNumber,100
	cmp eax,[ebx+CANIMAL_JUMP_INFO.JumpTendancy]
	    ja .exit

; extra jump condition values (ATX 1.61+)
; note: to make ATX display messages for the last "limiting" factors for the last dino jump
;       check/attempt, un-comment the SHOWTEMPMESSAGE instructions

   ; ebx = dino's jump info, esi = dino object, ebp = target instance ("dest" instance)

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_ALL
	     jz .exitnewconditiontests
	test ebp,ebp
	     jz .exitnewconditiontests

   ; pre-calculate vectors and facing values

	mov eax,[esi+CAnimal.lpCBoundaryBoxHead]
	lea edx,[AJN_DinoHeadFacing]
	lea ecx,[eax+CBoundaryBox.OrientationQuat]
	stdcall CONVERT_TO_FACING_PROC_010,edx,0		; get head's facing vector

	mov eax,[esi+CAnimal.lpCBoundaryBoxBody]
	lea edx,[AJN_DinoBodyFacing]
	lea ecx,[eax+CBoundaryBox.OrientationQuat]
	stdcall CONVERT_TO_FACING_PROC_010,edx,0		; get body's facing vector

	fld [ebp+CInstance.Location.X]				; get dino-target vector (x-y comp. only) and size
	fsub [esi+CAnimal.Location.X]
	fst [AJN_DinoTargetVector.X]
	fmul st0,st0
	fld [ebp+CInstance.Location.Y]
	fsub [esi+CAnimal.Location.Y]
	fst [AJN_DinoTargetVector.Y]
	fmul st0,st0
	faddp st1,st0
	fstp [AJN_DinoTargetVectorSizeExp2]

	push esi
	mov eax,[esi+28h]
	mov ecx,[eax+0Ch]
	lea eax,[AJN_DinoVelocityVector]
	mov edx,[ecx]
	push eax
	call DWORD [edx+28h]

	fld [AJN_DinoVelocityVector.X]
	fmul st0,st0
	fld [AJN_DinoVelocityVector.Y]
	fmul st0,st0
	faddp st1,st0
	fst [AJN_DinoVelocityVectorSize2DExp2]
	fld [AJN_DinoVelocityVector.Z]
	fmul st0,st0
	faddp st1,st0
	fstp [AJN_DinoVelocityVectorSizeExp2]

   ; begin tests

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINDISTANCE
	    jz .nomintargetdistance
  ; SHOWTEMPMESSAGE AJN_LASTTEST_MINDIST
	fld [ebx+CANIMAL_JUMP_INFO.MinTargetDistance]
	fcomp [AJN_DinoTargetVectorSizeExp2]
	fstsw ax
	test ah,FPU_VALUE_BELOW_OR_EQUAL
	     jz .exit
	.nomintargetdistance:

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXDISTANCE
	    jz .nomaxtargetdistance
  ;  SHOWTEMPMESSAGE AJN_LASTTEST_MAXDIST
	fld [AJN_DinoTargetVectorSizeExp2]
	fcomp [ebx+CANIMAL_JUMP_INFO.MaxTargetDistance]
	fstsw ax
	test ah,FPU_VALUE_BELOW_OR_EQUAL
	     jz .exit
	.nomaxtargetdistance:

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINTOTALSPEED
	    jz .nomintotalspeed
  ;  SHOWTEMPMESSAGE AJN_LASTTEST_MINSPEED
	fld [AJN_DinoVelocityVectorSizeExp2]				; 3d
	fcomp [ebx+CANIMAL_JUMP_INFO.MinTotalVelocity]
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz .exit
	.nomintotalspeed:

  ; must do sizeof.(projection of velocity vector onto body facing vector)
  ;            = componentof.() = dot product / magnitude(body vector)  (magnitude is 1.0)
	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MINDIRSPEED
	    jz .nominspeeddir
  ;  SHOWTEMPMESSAGE AJN_LASTTEST_MINSPEEDDIR
	fld [AJN_DinoVelocityVector.X]
	fmul [AJN_DinoBodyFacing.X]
	fld [AJN_DinoVelocityVector.Y]
	fmul [AJN_DinoBodyFacing.Y]
	fld [AJN_DinoVelocityVector.Z]
	fmul [AJN_DinoBodyFacing.Z]
	faddp st1,st0
	faddp st1,st0
	fcomp [ebx+CANIMAL_JUMP_INFO.MinVelocityDirectional]
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz .exit
	.nominspeeddir:

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXBODYANGLE
	    jz .nomaxbodytargetangle
  ;  SHOWTEMPMESSAGE AJN_LASTTEST_MAXBODYANGLE
	push esi
	push edi
	push ebx
	mov eax,[esi+CAnimal.lpCBoundaryBoxBody]
	lea edi,[ebp+CInstance.Location]
	lea esi,[eax+CBoundaryBox.Location]
	lea ebx,[ebx+CANIMAL_JUMP_INFO.MaxBodyAngleWithTarget]
	call CheckFacingBetweenInstanceAndTarget
	pop ebx
	pop edi
	pop esi
	test al,al
	     jz .exit
	.nomaxbodytargetangle:

	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXHEADANGLE
	    jz .nomaxheadtargetangle
  ;  SHOWTEMPMESSAGE AJN_LASTTEST_MAXHEADANGLE
	push esi
	push edi
	push ebx
	mov eax,[esi+CAnimal.lpCBoundaryBoxHead]
	lea edi,[ebp+CInstance.Location]
	lea esi,[eax+CBoundaryBox.Location]
	lea ebx,[ebx+CANIMAL_JUMP_INFO.MaxHeadAngleWithTarget]
	call CheckFacingBetweenInstanceAndTarget
	pop ebx
	pop edi
	pop esi
	test al,al
	     jz .exit
	.nomaxheadtargetangle:

   ; see CheckFacingBetweenInstanceAndTarget for details
	test [ebx+CANIMAL_JUMP_INFO.Flags],JUMP_INFO_NEWCOND_MAXDIRANGLE
	    jz .nomaxvelocityangle
   ; SHOWTEMPMESSAGE AJN_LASTTEST_MAXSPEEDANGLE
	fld [AJN_DinoBodyFacing.X]
	fmul st0,st0
	fld [AJN_DinoBodyFacing.Y]
	fmul st0,st0
	faddp st1,st0
	fsqrt							; sizeof.vector2 (dino body angle on x-y plane only)
	fld [AJN_DinoVelocityVectorSize2DExp2]
	fsqrt							; sizeof.vector1 (dino velocity on x-y plane only)
	fmulp st1,st0
	fmul [ebx+CANIMAL_JUMP_INFO.MaxVelocityDirAngle]	; cos(b)*sizeof.vector1*sizeof.vector2
	fld [AJN_DinoVelocityVector.X]
	fmul [AJN_DinoBodyFacing.X]
	fld [AJN_DinoVelocityVector.Y]
	fmul [AJN_DinoBodyFacing.Y]
	faddp st1,st0						; vector1.vector2
	fcompp							; vector1.vector2 >= cos(b)*sizeof.vector1*sizeof.vector2 ?
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz .exit						; if vector1.vector2 < cos(b)*sizeof.vector1*sizeof.vector2, then angle is above limit, quit
	.nomaxvelocityangle:

.exitnewconditiontests:

; stores tick count for true jump
	mov [ebx+CANIMAL_JUMP_INFO.LastTickCount],edi		; store last tick count

   ; SHOWTEMPMESSAGE AJN_LASTTEST_DINOJUMP

	call ForceDinoJump					; perform jump

.exit:
pop ebx
pop esi
pop edi
pop ebp
.preexit:
ret

