;===============================================================
ATXPROC CreateMainCAnimalBuffer
;===============================================================
; only creates buffer if one or more dino instances

push edi
push esi
push ebx

	LOCALRELEASE [CAnimalBuffer]
	xor eax,eax
	mov [CAnimalBufferSize],eax
	mov [CAnimalBufferEnd],eax
	mov [CAnimalInstanceCount],eax

; get number of CAnimal Instances

	mov ecx,[CANIMALCCREATRIGBUFADDR]		; this chain object buffer contains CAnimal and CCreatureTrigger objects (and others?)
	cmp DWORD [ecx+4],0
	    jz .nocreate

	mov ecx,[ecx]					; ecx = first chain object (dummy)
	test ecx,ecx
	     jz .nocreate

	mov esi,[ecx]
	cmp esi,ecx					; make sure the dummy object isn't the
	    jz .nocreate				; the last one, or there is an error in the list

	xor ebx,ebx					; count
	mov edx,[CANIMAL_VTABLE]

	.copyinstanceloop:
	mov eax,[esi+8] 				; CAnimal instance
	mov esi,[esi]					; next chain object
	add edi,sizeof.CANIMAL_INFO			; next buffer member
	cmp [eax],edx					; is object of CAnimal type?
	    jnz @f
	inc ebx
	@@:
	cmp esi,ecx
	    jnz .copyinstanceloop			; have we wrapped around to dummy instance?

	test ebx,ebx
	mov [CAnimalInstanceCount],ebx
	     jz .nocreate

; allocate space for one CANIMAL_INFO struc for each CAnimal instance

	mov eax,sizeof.CANIMAL_INFO
	mul ebx
	mov [CAnimalBufferSize],eax

	invoke LocalAlloc,LPTR,eax
	test eax,eax
	mov edi,eax
	    jz .nocreate

	mov [CAnimalBuffer],eax

; copy instances from game to CAnimalBuffer

	mov ecx,[CANIMALCCREATRIGBUFADDR]		; this chain object buffer contains CAnimal and CCreatureTrigger objects (and others?)   ;first instance in CAnimal instance "chain" (first is dummy)
	mov ecx,[ecx]

; "chain" (list) object format:
; DWORD [+00h] = pointer to next "chain object" (points to first dummy object if last)
; DWORD [+04h] = pointer to previous "chain object" (points to last object if first)
; DWORD [+08h] = CAnimal instance pointer

	mov esi,[ecx]
	cmp esi,ecx					; make sure the dummy object isn't the
	    jz .nocreate				; the last one, or there is an error in the list

; ecx = first (dummy) chain object

	xor ebx,ebx
	mov edx,[CANIMAL_VTABLE]

	.copyinstanceloop2:
	mov eax,[esi+8] 				; CAnimal instance
	mov esi,[esi]					; next chain object
	cmp [eax],edx					; is CAnimal?
	    jnz @f
	    mov [edi+CANIMAL_INFO.Instance],eax 	; store instance
	    mov [edi+CANIMAL_INFO.Index],ebx		; store instance number (relative to buffer start)
	    inc ebx
	    add edi,sizeof.CANIMAL_INFO 		; next buffer member
	@@:
	cmp esi,ecx
	    jnz .copyinstanceloop2			; have we wrapped around to dummy instance?

	mov eax,[CAnimalBuffer]
	add eax,[CAnimalBufferSize]
	mov [CAnimalBufferEnd],eax

pop ebx
pop esi
pop edi
ret

.nocreate:

     LOCALRELEASE [CAnimalBuffer]
     mov [CAnimalBufferSize],0

pop ebx
pop esi
pop edi
ret

;===============================================================
ATXPROC SaveCAnimalInitialData
;===============================================================
push edi
push esi

	mov ebx,[CAnimalBuffer]
	test ebx,ebx
	     jz .nosave

	.saveloop:
	mov eax,[ebx+CANIMAL_INFO.Instance]
	lea edi,[ebx+CANIMAL_INFO.InitialPos]
	lea esi,[eax+30h]
	mov ecx,7
	rep movsd
	add ebx,sizeof.CANIMAL_INFO
	cmp ebx,[CAnimalBufferEnd]
	    jb .saveloop

.nosave:
pop esi
pop edi
ret