;============================================================
; CBackDrop Instance Collector
;============================================================
; optimized for lower counts in CBackDrop instances

;============================================================
INTERCEPTPROC CBACKDROPCOLLECTMAIN		; must preserve eax,esi,edi,ebx,ebp
;============================================================
; eax = instance of CBackDrop

push esi
push edi
push ebx
mov ebx,eax

	mov ecx,[CBackDropInstanceCount]
	test ecx,ecx
	     jnz .nonewbuffer

		invoke LocalAlloc,LMEM_FIXED,(CBACKDROP_BUFFER_INSTCOUNT_INITIAL*4)
		test eax,eax
		     jz .exit

		mov [CBackDropBuffer],eax
		mov [CBackDropBufferCapacity],CBACKDROP_BUFFER_INSTCOUNT_INITIAL
		jmp .nobufferrealloc

	.nonewbuffer:

	cmp ecx,[CBackDropBufferCapacity]
	    jb .nobufferrealloc

		add ecx,CBACKDROP_BUFFER_INSTCOUNT_INITIAL
		shl ecx,2
		invoke LocalAlloc,LMEM_FIXED,ecx		; create new buffer
		test eax,eax
		mov edi,eax
		    jz .exit

		mov esi,[CBackDropBuffer]
		mov ecx,[CBackDropInstanceCount]		; copy old buffer to new
		mov [CBackDropBuffer],edi
		add [CBackDropBufferCapacity],CBACKDROP_BUFFER_INSTCOUNT_INITIAL
		rep movsd

	.nobufferrealloc:

	mov eax,[CBackDropBuffer]
	mov ecx,[CBackDropInstanceCount]
	mov [eax+4*ecx],ebx					; add instance to buffer
	inc ecx
	mov [CBackDropInstanceCount],ecx

.exit:
mov eax,ebx
pop ebx
pop edi
pop esi
add esp,0C0h							; REPLACED CODE
ret

;============================================================
ATXPROC CBACKDROPBUFFERRELEASE
;============================================================

	xor ecx,ecx
	mov eax,[CBackDropBuffer]
	mov [CBackDropInstanceCount],ecx
	mov [CBackDropBuffer],ecx
	mov [CBackDropBufferCapacity],ecx
	LOCALRELEASENONULL eax

ret

;============================================================
ATXPROC CBACKDROPFINDINSTANCEFROMID		; eax=stringID of instance to find
;============================================================
; returns instance in eax or NULL

push ebx

	mov ecx,[CBackDropInstanceCount]
	mov ebx,[CBackDropBuffer]
	test ecx,ecx
	     jz .notfound

	.searchloop:
	mov edx,[ebx]
	cmp eax,[edx+CInstance.InstanceNameID]
	    jz .found
	add ebx,4
	loop .searchloop
	.notfound:
	xor eax,eax

pop ebx
ret

.found:
	mov eax,edx
pop ebx
ret


