;============================================================
ATXPROC IsPlayerHoldingCGun			; destroyed: eax,edx, returns 0 if false or CGun object otherwise
;============================================================

	mov eax,[ACTIVE_GUN_REF_ADDR]
	mov edx,[eax]

	test edx,edx
	     jz .notholding

	mov eax,[edx]

	test eax,eax
	     jz .notholding

	mov edx,[eax+08h]

	test edx,edx
	     jz .notholding

	mov eax,[edx+GETWEAPON_PRIMARY] 	; eax = possible primary CGun object (object held by Anne)
	test eax,eax
	mov edx,[CGUNVTABLE]
	     jz .exitproc			; make sure player is holding an object
	cmp [eax+CInstance.lpVTable],edx
	    jz .exitproc

.notholding:

	xor eax,eax

.exitproc:
ret

;============================================================
ATXPROC GetHeldWeaponInstance			; ecx = which weapon offset
;============================================================
; returns gun in eax or null if holding nothing or if not gun

	mov eax,[ACTIVE_GUN_REF_ADDR]
	mov edx,[eax]

	test edx,edx
	     jz .none

	mov eax,[edx]

	test eax,eax
	     jz .none

	mov edx,[eax+08h]

	test edx,edx
	     jz .none

	cmp ecx,GETWEAPON_SECONDARY		; special case (must check two objects)
	    jz .checksecondary

	mov eax,[edx+ecx]
	test eax,eax
	mov edx,[CGUNVTABLE]
	     jz .none
	cmp [eax],edx
	    jnz .none

ret

.checksecondary:				; two cases to verify when not specifying a location for the secondary weapon

	mov eax,[edx+GETWEAPON_SECONDARYWAIST]
	mov ecx,[CGUNVTABLE]
	test eax,eax
	     jz .notwaist
	cmp [eax],ecx
	    jz .secondaryfound
	.notwaist:

	mov eax,[edx+GETWEAPON_SECONDARYBACK]
	test eax,eax
	     jz .none
	cmp [eax],ecx
	    jnz .none

.secondaryfound:
ret

.none:

	xor eax,eax

ret

