; compile using FASM (see "SOURCE_README.txt" for last version used)
; NOTE: This version of the patcher is only used to patch the
; already-available ATX Trespasser executables.

PATCHER_VERSION 	equ	'3.1'

;=================================================================
format PE GUI 4.0
entry START
stack 20000h
;=================================================================
; required: GetOpenFileName may crash under certain circumstances if stack is too small
; (witnessed with WinRAR menu options, when right-clicking on an EXE file)

include '%fasminc%\WIN32A.INC'	; must have FASM environment variable set properly for this
include 'ATX_PATCH_VALUES.inc'

;=================================================================
section '.code' code readable executable
;=================================================================
align 16

START:

push ebp
mov ebp,esp
push ebx
push edi
push esi

	xor ebx,ebx	; ebx = file handle
			; edi = error message pointer

	mov [OFN_info.lStructSize],sizeof.OPENFILENAME
	mov [OFN_info.lpstrFilter],filter_strings
	mov [OFN_info.lpstrFile],source_file
	mov [OFN_info.nMaxFile],512
	mov [OFN_info.lpstrDefExt],default_extension
	mov [OFN_info.lpstrTitle],open_file_caption
	mov [OFN_info.Flags],OFN_FILEMUSTEXIST+OFN_LONGNAMES+OFN_PATHMUSTEXIST+OFN_EXPLORER+OFN_HIDEREADONLY

	invoke GetOpenFileName,OFN_info
	test eax,eax
	mov edi,0
	     jz MAINEXIT

	mov edi,dest_file
	mov esi,source_file

	copyfilenameloop:
	mov al,[esi]
	mov [edi],al
	test al,al
	     jz filenameendfound
	inc edi
	inc esi
	jmp copyfilenameloop
	filenameendfound:

	mov DWORD [edi-4],'ATX2'
	mov esi,edi
	mov DWORD [edi],'DEMO'
	mov DWORD [edi+4],'.exe'
	mov BYTE [edi+59],0
	lea ecx,[edi+8]

	@@:
	dec esi
	cmp BYTE [esi],'\'
	    jnz @b

	inc esi
	sub ecx,esi
	mov edi,WriteSuccessFileName
	rep movsb

	mov ecx,(EndSuccessEndText-SuccessEndText)/4
	mov esi,SuccessEndText
	rep movsd

	invoke CopyFile,source_file,dest_file,FALSE
	test eax,eax
	mov edi,ErrorText1
	    jz MAINEXIT

	invoke SetFileAttributes,dest_file,FILE_ATTRIBUTE_NORMAL
	test eax,eax
	mov edi,ErrorText6
	     jz MAINEXIT

	invoke CreateFile,dest_file,GENERIC_WRITE,FILE_SHARE_WRITE,0,OPEN_EXISTING,\
			  FILE_ATTRIBUTE_NORMAL,0,0
	test eax,eax
	mov edi,ErrorText2
	     jz MAINEXIT
	cmp eax,-1
	    jz MAINEXIT

	mov ebx,eax

	invoke GetFileSize,eax
	cmp eax,-1
	mov edi,ErrorText3
	    jz MAINEXIT

	mov [filesize],eax


	cmp eax,_exe_P5_Demo_Size
	    jz DETECT_EXE_SUCCESS

	mov edi,ErrorText5
	jmp MAINEXIT


	DETECT_EXE_SUCCESS:


DEMOMAINCODESIZE1 = (END_DEMOMAINCODE-Demo_maincode)		       ; must be <= 3AA
DEMOMAINCODESIZE2 = (END_DEMOMAINCODESELFMOD-Demo_maincodeselfmod)     ; must be <= 34B


	WRITE_EXE_CODE DEMO_ENTRYPOINT_ADDR,DEMO_JUMP,\
		       5,ErrorText4
	WRITE_EXE_CODE DEMO_TEXT_DEST_ADDR,Demo_maincode2,\
		       DEMOMAINCODESIZE1,ErrorText4
	WRITE_EXE_CODE DEMO_SELFMOD_DEST_ADDR,Demo_maincodeselfmod2,\
		       DEMOMAINCODESIZE2,ErrorText4


	mov esi,demo_exe_name_type
	mov ecx,10
	mov edi,ExeShowType
	rep movsd

	mov edi,WriteSuccess
	invoke CloseHandle,ebx		;success!

	jmp show_msgbox

;=================================================================
MAINEXIT:

	test ebx,ebx
	     jz @f

		invoke CloseHandle,ebx

	@@:

	test edi,edi
	     jz @f

		invoke DeleteFile,dest_file

	@@:

	test edi,edi
	     jz no_msgbox

show_msgbox:

		invoke MessageBox,0,edi,msgbox_caption,0

	no_msgbox:

	pop esi
	pop edi
	pop ebx
	mov esp,ebp
	pop ebp

	invoke ExitProcess,0

;=================================================================
section '.data' data readable writeable
;=================================================================

dd DEMOMAINCODESIZE1
dd DEMOMAINCODESIZE2

align 16
OFN_info		OPENFILENAME

filter_strings		db	"Executable files",0,"*.exe",0
			db	"All files",0,"*.*",0,0
default_extension	db	"exe",0
open_file_caption	db	"ATX Trespasser 2.00+ Demo-Only Patcher - select executable to patch",0
msgbox_caption		db	"ATX Trespasser 2.00+ Demo-Only Patcher",0

source_file		db	512 dup 0
dest_file		db	512 dup 0

filesize		dd	0
byteswritten		dd	0

WriteSuccess		db	"Detected executable type:",0Dh,0Ah
   ExeShowType		db	40 dup 0
			db	0Dh,0Ah,"Executable successfully copied and patched as:",0Dh,0Ah
WriteSuccessFileName	db	500 dup 0

SuccessEndText		db	0Dh,0Ah
			db	0Dh,0Ah,"Please read ATX_README.htm before using."
			db	0Dh,0Ah,"Note: the executable created by this patcher is valid"
			db	0Dh,0Ah,"for ATX versions above 2.00 only."
			dd	0
	EndSuccessEndText:

ErrorText1		db	"Could not copy specified file.",0
ErrorText2		db	"New file could not be opened for writing.",0
ErrorText3		db	"Could not get file size.",0
ErrorText4		db	"Could not write to copy of specified file.",0
ErrorText5		db	"Unsupported Trespasser executable.",0Dh,0Ah
			db	"Requires demo executable version 1.1 (1.0.117.0).",0
ErrorText6		db	"Could not set file attributes.",0

;=================================================================
section '.exedata' data readable writeable
;=================================================================

demo_exe_name_type	db     "Demo (Pentium P5) Executable                                                                   ",0

MACRO EXE_ADDR exeorg {
	currentaddr=$
	org exeorg
	startinstrexe=$
      }

MACRO ADDR_RESTORE {
	restoredaddr=($-startinstrexe)+currentaddr
	org restoredaddr
      }


DEMO_JUMP:
	EXE_ADDR DEMO_ENTRYPOINT_ADDR
	call DEMO_TEXT_DEST_ADDR
	ADDR_RESTORE

Demo_maincode2:
	EXE_ADDR DEMO_TEXT_DEST_ADDR
	Demo_maincode:
		MAIN_CODE
	END_DEMOMAINCODE:
	ADDR_RESTORE

Demo_maincodeselfmod2:
	EXE_ADDR DEMO_SELFMOD_DEST_ADDR
	Demo_maincodeselfmod:
		MAIN_CODESELFMOD
	END_DEMOMAINCODESELFMOD:
	ADDR_RESTORE

;=================================================================
section '.idata' import data readable writeable
;=================================================================

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  comdlg,'COMDLG32.DLL'

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 DeleteFile,"DeleteFileA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 SetFilePointer,'SetFilePointer',\
	 SetFileAttributes,'SetFileAttributesA',\
	 WriteFile,'WriteFile'

  import user,\
	 MessageBox,'MessageBoxA'

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_ICON,icons,\
		  RT_GROUP_ICON,group_icons,\
		  RT_VERSION,versions

	resource icons,\
		 1,LANG_NEUTRAL,icon_data

	resource group_icons,\
		 17,LANG_NEUTRAL,main_icon

	resource versions,\
		 1,LANG_NEUTRAL,version

	icon main_icon,icon_data,'patchericon.ico'

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
		    LANG_ENGLISH+SUBLANG_DEFAULT,0,\
		    'FileDescription','ATX Trespasser executable patcher',\
		    'LegalCopyright','Free.',\
		    'FileVersion',PATCHER_VERSION,\
		    'ProductVersion',PATCHER_VERSION,\
		    'OriginalFilename','ATX_PATCHER.EXE'

